# Entities

* [Mainnet Subgraph](https://thegraph.com/hosted-service/subgraph/dfx-finance/dfx-v1)
* [Polygon Subgraph](https://thegraph.com/hosted-service/subgraph/dfx-finance/dfx-v1-polygon)

***

### Trade

Data of every trade made in the DFX pools

<table><thead><tr><th width="168">Field</th><th width="150">Type</th><th>Units</th><th>Description</th></tr></thead><tbody><tr><td>id</td><td>ID</td><td>66 char hex string - event number</td><td>a trade's transaction hash concatenated by event number</td></tr><tr><td>timestamp</td><td>BigInt</td><td>seconds</td><td>unix timestamp of the trade</td></tr><tr><td>pair</td><td>Pair</td><td>object</td><td>pool contract pair object</td></tr><tr><td>trader</td><td>Bytes</td><td>42 char hex string</td><td>address executing the trade</td></tr><tr><td>origin</td><td>Bytes</td><td>42 char hex string</td><td>address of the token given during the trade</td></tr><tr><td>target</td><td>Bytes</td><td>42 char hex string</td><td>address of the token received during the trade</td></tr><tr><td>originAmount</td><td>BigInt</td><td>integer without decimal adjustment</td><td>raw amount of tokens given during the trade</td></tr><tr><td>targetAmount</td><td>BigInt</td><td>integer without decimal adjustment</td><td>raw amount of tokens received during the trade</td></tr></tbody></table>

***

### Transfer

Data of every single transfer made in the DFX pools

<table><thead><tr><th width="177.12843625271734">Field</th><th width="150">Type</th><th width="186.0920788642363">Units</th><th>Description</th></tr></thead><tbody><tr><td>id</td><td>ID</td><td>66 char hex string - event number</td><td>trade's transaction hash concatenated by event number</td></tr><tr><td>timestamp</td><td>BigInt</td><td>seconds</td><td>unix timestamp of the transfer</td></tr><tr><td>pair</td><td>Pair</td><td>object</td><td>pool contract pair object</td></tr><tr><td>from</td><td>Bytes</td><td>42 char hex string</td><td>address sending the token</td></tr><tr><td>to</td><td>Bytes</td><td>42 char hex string</td><td>address receiving the token</td></tr><tr><td>token0Amount</td><td>BigDecimal</td><td>US dollar</td><td>amount of US dollars transferred</td></tr><tr><td>token1Amount</td><td>BigDecimal</td><td>foreign stablecoin dollar</td><td>amount of foreign stablecoin dollars transferred</td></tr><tr><td>value</td><td>BigInt</td><td>raw amount without decimal adjustment</td><td>raw amount of tokens transferred</td></tr><tr><td>type</td><td>String</td><td>withdraw, two-sided-deposit, single-sided-deposit, single-sided-deposit-ignore, stake, unstake, LP-transfer</td><td>type of transfer that is being made in the pools</td></tr></tbody></table>

***

### DFXFactory

Data across all DFX stablecoin pools

<table><thead><tr><th>Field</th><th width="150">Type</th><th width="171">Units</th><th>Description</th></tr></thead><tbody><tr><td>id</td><td>ID</td><td>42 char hex string</td><td>factory contract address</td></tr><tr><td>pairCount</td><td>Int</td><td>integer</td><td>number of unique foreign stablecoin / USD pairs produced by the factory contract</td></tr><tr><td>totalVolumeUSD</td><td>BigDecimal</td><td>US dollar</td><td>total volume in US dollars for all tokens traded across all DFX pools</td></tr><tr><td>totalLiquidityUSD</td><td>BigDecimal</td><td>US dollar</td><td>total liquidity in US dollar for all tokens across all DFX pools</td></tr></tbody></table>

***

### DFXDayData

Daily data across all DFX stablecoin pools

<table><thead><tr><th>Field</th><th width="150">Type</th><th width="171">Units</th><th>Description</th></tr></thead><tbody><tr><td>id</td><td>ID</td><td>days</td><td>unix timestamp for the start of the day / 86400</td></tr><tr><td>date</td><td>unix</td><td>seconds</td><td>unix timestamp of a particular date</td></tr><tr><td>dailyVolumeUSD</td><td>BigDecimal</td><td>US dollar</td><td>total volume in US dollars for all tokens traded across all DFX pools for a particular date</td></tr><tr><td>totalVolumeUSD</td><td>BigDecimal</td><td>US dollar</td><td>daily snapshot of the total volume in US dollars for all tokens traded across all DFX pools</td></tr><tr><td>totalLiquidityUSD</td><td>BigDecimal</td><td>US dollar</td><td>daily snapshot of the total liquidity in US dollars across all DFX pools</td></tr></tbody></table>

***

### PairHourData

Hourly data on individual DFX stablecoin pools

<table><thead><tr><th>Field</th><th width="150">Type</th><th width="171">Units</th><th>Description</th></tr></thead><tbody><tr><td>id</td><td>ID</td><td>42 char hex string - hours</td><td>pool contract address concatenated by unix timestamp in hours</td></tr><tr><td>hourStartUnix</td><td>Int</td><td>hours</td><td>unix timestamp of a particular hours</td></tr><tr><td>pair</td><td>Pair</td><td>object</td><td>pool contract pair object</td></tr><tr><td>firstTxn</td><td>Bytes</td><td>66 char hex string</td><td>transaction hash of the first trade made in the pool for a particular date</td></tr><tr><td>reserve0</td><td>BigDecimal</td><td>US dollar</td><td>liquidity of the US dollar side of a pool for a particular hour</td></tr><tr><td>reserve1</td><td>BigDecimal</td><td>foreign stablecoin dollar</td><td>liquidity of foreign stablecoin side of a pool for a particular hour</td></tr><tr><td>reserveUSD</td><td>BigDecimal</td><td>US dollar</td><td>total liquidity in US dollars in the pool for a particular hour</td></tr><tr><td>swapRateUSD</td><td>BigDecimal</td><td>US dollar</td><td>price of 1 foreign stablecoin token in US dollar for a particular hour</td></tr><tr><td>volumeToken0</td><td>BigDecimal</td><td>US dollar</td><td>volume of USDC traded within the pool for a particular hour</td></tr><tr><td>volumeToken1</td><td>BigDecimal</td><td>foreign stablecoin dollar</td><td>volume of foreign stablecoin traded within the pool for a particular hour</td></tr><tr><td>volumeUSD</td><td>BigDecimal</td><td>US dollar</td><td>total volume in US dollars for both tokens traded within the pool for a particular hour</td></tr><tr><td>participantCount</td><td>BigInt</td><td>integer</td><td>number of unique addresses that has made a trade in the pool for a particular hour</td></tr></tbody></table>

***

### PairDayData

Daily data on individual DFX stablecoin pools

<table><thead><tr><th width="217.48959778085992">Field</th><th width="150">Type</th><th width="171">Units</th><th>Description</th></tr></thead><tbody><tr><td>id</td><td>ID</td><td>42 char hex string - days</td><td>pool contract address concatenated by unix timestamp in days</td></tr><tr><td>date</td><td>Int</td><td>seconds</td><td>unix timestamp of a particular date</td></tr><tr><td>pair</td><td>Pair</td><td>object</td><td>pool that the participant is interacting with </td></tr><tr><td>firstTxn</td><td>Bytes</td><td>66 char hex string</td><td>transaction hash of the first trade made in the pool for a particular date</td></tr><tr><td>reserve0</td><td>BigDecimal</td><td>US dollar</td><td>liquidity of the US dollar side of the pool for a particular date</td></tr><tr><td>reserve1</td><td>BigDecimal</td><td>foreign stablecoin dollar</td><td>liquidity of foreign stablecoin side of the pool for a particular date</td></tr><tr><td>reserveUSD</td><td>BigDecimal</td><td>US dollar</td><td>total liquidity in US dollars in the pool for a particular date</td></tr><tr><td>reserve0Deposit</td><td>BigDecimal</td><td>US dollar</td><td>liquidity deposited of the US dollar side of the pool for a particular date</td></tr><tr><td>reserve1Deposit</td><td>BigDecimal</td><td>foreign stablecoin dollar</td><td>liquidity deposited of foreign stablecoin side of the pool for a particular date</td></tr><tr><td>reserve1DepositUSD</td><td>BigDecimal</td><td>US dollar</td><td>liquidity deposited of foreign stablecoin in US dollars side of the pool for a particular date</td></tr><tr><td>reserve0Withdraw</td><td>BigDecimal</td><td>US dollar</td><td>liquidity withdraw of the US dollar side of the pool for a particular date</td></tr><tr><td>reserve1Withdraw</td><td>BigDecimal</td><td>foreign stablecoin dollar</td><td>liquidity withdraw of foreign stablecoin side of the pool for a particular date</td></tr><tr><td>reserve1DepositUSD</td><td>BigDecimal</td><td>US dollar</td><td>liquidity withdraw of foreign stablecoin in US dollars side of the pool for a particular date</td></tr><tr><td>swapRateUSD</td><td>BigDecimal</td><td>US dollar</td><td>price of 1 foreign stablecoin token in US dollar for a particular day</td></tr><tr><td>volumeToken0</td><td>BigDecimal</td><td>US dollar</td><td>volume of USDC traded within the pool for a particular day</td></tr><tr><td>volumeToken1</td><td>BigDecimal</td><td>foreign stablecoin dollar</td><td>volume of foreign stablecoin traded within the pool for a particular day</td></tr><tr><td>volumeUSD</td><td>BigDecimal</td><td>US dollar</td><td>total volume in US dollars for both tokens traded within the pool for a particular day</td></tr><tr><td>participantCount</td><td>BigInt</td><td>integer</td><td>number of unique addresses that has made a trade in the pool for a particular day</td></tr></tbody></table>

***

### Pair

Data on DFX individual stablecoin pools

<table><thead><tr><th width="223.48959778085992">Field</th><th width="150.70727695113612">Type</th><th width="171">Units</th><th>Description</th></tr></thead><tbody><tr><td>id</td><td>ID</td><td>address (42 char hex string)</td><td>address of the pool</td></tr><tr><td>token0</td><td>Token</td><td>address (42 char hex string)</td><td>address of the US dollar in the pool</td></tr><tr><td>token1</td><td>Token</td><td>address (42 char hex string)</td><td>address of the foreign stablecoin in the pool</td></tr><tr><td>reserve0</td><td>BigDecimal</td><td>US dollar </td><td>liquidity of the US dollar side of the pool</td></tr><tr><td>reserve1</td><td>BigDecimal</td><td>foreign stablecoin dollar </td><td>liquidity of foreign stablecoin side of the pool</td></tr><tr><td>reserveUSD</td><td>BigDecimal</td><td>US dollar</td><td>total liquidity in US dollars in the pool</td></tr><tr><td>swapRateUSD</td><td>BigDecimal</td><td>US dollar</td><td>price of 1 foreign stablecoin token in US dollar</td></tr><tr><td>rewardsForDuration</td><td>BigDecimal</td><td>decimal</td><td>number of DFX allocated for liquidity providers for a particular duration</td></tr><tr><td>rewardDuration</td><td>BigInt</td><td>seconds</td><td>unix time of rewards distribution period</td></tr><tr><td>totalStaked</td><td>BigDecimal</td><td>decimal</td><td>number of LP tokens staked for this stablecoin pair</td></tr><tr><td>volumeToken0</td><td>BigDecimal</td><td>US dollar</td><td>volume of USDC traded within the pool</td></tr><tr><td>volumeToken1</td><td>BigDecimal</td><td>US dollar</td><td>volume of foreign stablecoin traded within the pool</td></tr><tr><td>volumeUSD</td><td>BigDecimal</td><td>US dollar</td><td>total volume in US dollars of both tokens traded within the pool</td></tr><tr><td>txnsCount</td><td>BigInt</td><td>integer</td><td>total number of trades made in the pool</td></tr><tr><td>participantCount</td><td>BigInt</td><td>integer</td><td>total number of unique addresses that has made a trade in the pool</td></tr><tr><td>totalLPToken</td><td>BigDecimal</td><td>decimal</td><td>total number of LP tokens minted for the pool</td></tr><tr><td>hourData</td><td>Array of PairHourData</td><td>array of objects</td><td>all hourly data on the token pool</td></tr></tbody></table>

***

### Token

Data on individual foreign stablecoins traded on DFX

<table><thead><tr><th>Field</th><th width="150">Type</th><th width="171">Units</th><th>Description</th></tr></thead><tbody><tr><td>id</td><td>ID</td><td>42 char hex string</td><td>address of token</td></tr><tr><td>decimals</td><td>BigInt</td><td>integer</td><td>decimal place the amount the token takes</td></tr><tr><td>symbol</td><td>String</td><td>string </td><td>3 to 4 letter abbreviation of token name</td></tr><tr><td>name</td><td>String</td><td>string</td><td>full token name</td></tr><tr><td>priceUSD</td><td>BigDecimal</td><td>US dollar</td><td>price of 1 token in US dollar</td></tr><tr><td>tokenDayData</td><td>Array of TokenDayDatas</td><td>array of objects</td><td>all daily data on the token described</td></tr></tbody></table>

***

### TokenDayData

Daily data on individual foreign stablecoin traded on DFX

<table><thead><tr><th>Field</th><th width="150">Type</th><th width="171">Units</th><th>Description</th></tr></thead><tbody><tr><td>id</td><td>ID</td><td>42 char hex string - unix date in seconds</td><td>address of token concatenated by unix timestamp of the day</td></tr><tr><td>date</td><td>BigInt</td><td>seconds</td><td>unix timestamp of a particular date</td></tr><tr><td>token</td><td>Token</td><td>object</td><td>token that is being tracked</td></tr><tr><td>dailyVolumeToken</td><td>BigDecimal</td><td>foreign stablecoin dollars</td><td>volume in foreign stablecoin dollars that has been traded on a particular day</td></tr><tr><td>dailyVolumeUSD</td><td>BigDecimal</td><td>US dollars</td><td>volume in US dollars equivalent that has been traded on a particular day</td></tr><tr><td>priceUSD</td><td>BigDecimal</td><td>US dollars</td><td>price of 1 token in US dollars </td></tr></tbody></table>

***

### PoolParticipant

Data of every address that has made a trade or provided liquidity on one of the DFX pools

<table><thead><tr><th width="177.15268014506856">Field</th><th width="150">Type</th><th width="171">Units</th><th>Description</th></tr></thead><tbody><tr><td>id</td><td>ID</td><td>42 char hex string - 42 char hex string</td><td>address of pool concatenated by address of participant</td></tr><tr><td>pair</td><td>Pair</td><td>object</td><td>pool that the participant is interacting with </td></tr><tr><td>participant</td><td>Bytes</td><td>42 char hex string</td><td>address executing the trades or liquidity provision</td></tr><tr><td>volumeUSD</td><td>BigDecimal</td><td>US dollars</td><td>US dollar volume the user has traded within a particular pool</td></tr><tr><td>liquidityProvided</td><td>BigDecimal</td><td>decimal</td><td>number of LP tokens the user has minted within a particular pool</td></tr></tbody></table>


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.dfx.finance/dfx-finance/dev-zone/subgraphs/entities.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
